'/*
'** $Id: lauxlib.h,v 1.88 2006/04/12 20:31:15 roberto Exp $
'** Auxiliary functions for building Lua libraries
'** See Copyright Notice in lua.h
'*/

#IF NOT %DEF(%LAUXLIB_INC)
    %LAUXLIB_INC = 1

'#include <stddef.h>
'#include <stdio.h>

#INCLUDE ONCE "lua.inc"

'#if defined(LUA_COMPAT_GETN)
'LUALIB_API int (luaL_getn) (lua_State *L, int t);
'LUALIB_API void (luaL_setn) (lua_State *L, int t, int n);
'#else
'#define luaL_getn(L,i)          ((int)lua_objlen(L, i))
'#define luaL_setn(L,i,j)        ((void)0)  /* no op! */
'#endif

'#if defined(LUA_COMPAT_OPENLIB)
'#define luaI_openlib	luaL_openlib
'#endif


'/* extra error code for `luaL_load' */
%LUA_ERRFILE = %LUA_ERRERR + 1

TYPE luaL_Reg
   name AS ASCIIZ PTR   ' const char *name
   func AS DWORD        ' lua_CFunction func
END TYPE


DECLARE SUB luaI_openlib LIB "LUA5.1.DLL" ALIAS "luaI_openlib" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *libname
 , BYREF luaL_Reg _                    ' const luaL_Reg *l
 , BYVAL LONG _                        ' int nup
 )                                     ' void

DECLARE SUB luaL_register LIB "LUA5.1.DLL" ALIAS "luaL_register" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *libname
 , BYREF luaL_Reg _                    ' const luaL_Reg *l
 )                                     ' void

DECLARE FUNCTION luaL_getmetafield LIB "LUA5.1.DLL" ALIAS "luaL_getmetafield" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int obj
 , BYREF ASCIIZ _                      ' const char *e
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_callmeta LIB "LUA5.1.DLL" ALIAS "luaL_callmeta" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int obj
 , BYREF ASCIIZ _                      ' const char *e
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_typerror LIB "LUA5.1.DLL" ALIAS "luaL_typerror" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narg
 , BYREF ASCIIZ _                      ' const char *tname
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_argerror LIB "LUA5.1.DLL" ALIAS "luaL_argerror" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int numarg
 , BYREF ASCIIZ _                      ' const char *extramsg
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_checklstring LIB "LUA5.1.DLL" ALIAS "luaL_checklstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int numArg
 , BYREF DWORD _                       ' size_t *l
 ) AS DWORD                            ' const char *

DECLARE FUNCTION luaL_optlstring LIB "LUA5.1.DLL" ALIAS "luaL_optlstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int numArg
 , BYREF ASCIIZ _                      ' const char *def
 , BYREF DWORD _                       ' size_t *l
 ) AS DWORD                            ' const char *

DECLARE FUNCTION luaL_checknumber LIB "LUA5.1.DLL" ALIAS "luaL_checknumber" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int numArg
 ) AS DOUBLE                           ' lua_Number

DECLARE FUNCTION luaL_optnumber LIB "LUA5.1.DLL" ALIAS "luaL_optnumber" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int nArg
 , BYVAL DOUBLE _                      ' lua_Number def
 ) AS DOUBLE                           ' lua_Number

DECLARE FUNCTION luaL_checkinteger LIB "LUA5.1.DLL" ALIAS "luaL_checkinteger" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int numArg
 ) AS LONG                             ' lua_Integer

DECLARE FUNCTION luaL_optinteger LIB "LUA5.1.DLL" ALIAS "luaL_optinteger" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int nArg
 , BYVAL LONG _                        ' lua_Integer def
 ) AS LONG                             ' lua_Integer

DECLARE SUB luaL_checkstack LIB "LUA5.1.DLL" ALIAS "luaL_checkstack" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int sz
 , BYREF ASCIIZ _                      ' const char *msg
 )                                     ' void

DECLARE SUB luaL_checktype LIB "LUA5.1.DLL" ALIAS "luaL_checktype" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narg
 , BYVAL LONG _                        ' int t
 )                                     ' void

DECLARE SUB luaL_checkany LIB "LUA5.1.DLL" ALIAS "luaL_checkany" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narg
 )                                     ' void

DECLARE FUNCTION luaL_newmetatable LIB "LUA5.1.DLL" ALIAS "luaL_newmetatable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *tname
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_checkudata LIB "LUA5.1.DLL" ALIAS "luaL_checkudata" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG_                         ' int ud
 , BYREF ASCIIZ _                      ' const char *tname
 ) AS DWORD                             ' void *

DECLARE SUB luaL_where LIB "LUA5.1.DLL" ALIAS "luaL_where" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int lvl
 )                                     ' void

DECLARE FUNCTION luaL_error CDECL LIB "LUA5.1.DLL" ALIAS "luaL_error" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *fmt
 , OPTIONAL BYREF ANY _                ' optional arguments
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_checkoption LIB "LUA5.1.DLL" ALIAS "luaL_checkoption" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narg
 , BYREF ASCIIZ _                      ' const char *def
 , BYREF ASCIIZ _                      ' const char *const lst[]
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_ref LIB "LUA5.1.DLL" ALIAS "luaL_ref" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int t
 ) AS LONG                             ' int

DECLARE SUB luaL_unref LIB "LUA5.1.DLL" ALIAS "luaL_unref" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int t
 , BYVAL LONG _                        ' int ref
 )                                     ' void

DECLARE FUNCTION luaL_loadfile LIB "LUA5.1.DLL" ALIAS "luaL_loadfile" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *filename
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_loadbuffer LIB "LUA5.1.DLL" ALIAS "luaL_loadbuffer" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *buff
 , BYVAL DWORD _                       ' size_t sz
 , BYREF ASCIIZ _                      ' const char *name
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_loadstring LIB "LUA5.1.DLL" ALIAS "luaL_loadstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *s
 ) AS LONG                             ' int

DECLARE FUNCTION luaL_newstate LIB "LUA5.1.DLL" ALIAS "luaL_newstate" ( _
 ) AS DWORD                            ' lua_State *

DECLARE FUNCTION luaL_gsub LIB "LUA5.1.DLL" ALIAS "luaL_gsub" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *s
 , BYREF ASCIIZ _                      ' const char *p
 , BYREF ASCIIZ _                      ' const char *r
 ) AS DWORD                            ' const char *

DECLARE FUNCTION luaL_findtable LIB "LUA5.1.DLL" ALIAS "luaL_findtable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYREF ASCIIZ _                      ' const char *fname
 , BYVAL LONG _                        ' int szhint
 ) AS DWORD                            ' const char *


'/*
'** ===============================================================
'** some useful macros
'** ===============================================================
'*/

'#define luaL_argcheck(L, cond,numarg,extramsg)	\
'		((void)((cond) || luaL_argerror(L, (numarg), (extramsg))))

FUNCTION luaL_argcheck (BYVAL L AS DWORD, BYVAL cond AS DWORD, BYVAL numarg AS LONG, BYREF extramsg AS ASCIIZ) AS LONG
   LOCAL lr AS LONG
   FUNCTION = luaL_argerror(L, numarg, extramsg)
   FUNCTION = cond OR lr
END FUNCTION

'#define luaL_checkstring(L,n)	(luaL_checklstring(L, (n), NULL))

MACRO luaL_checkstring(L,n) = luaL_checklstring(L, n, %NULL)

'#define luaL_optstring(L,n,d)	(luaL_optlstring(L, (n), (d), NULL))

MACRO luaL_optstring(L,n) = luaL_optlstring(L, n, d, %NULL)

'#define luaL_checkint(L,n)	((int)luaL_checkinteger(L, (n)))

MACRO luaL_checkint(L,n) = luaL_checkinteger(L, n)

'#define luaL_optint(L,n,d)	((int)luaL_optinteger(L, (n), (d)))

MACRO luaL_optint(L,n,d) = luaL_optinteger(L, n, d)

'#define luaL_checklong(L,n)	((long)luaL_checkinteger(L, (n)))

MACRO luaL_checklong(L,n) = luaL_checkinteger(L, n)

'#define luaL_optlong(L,n,d)	((long)luaL_optinteger(L, (n), (d)))

MACRO luaL_optlong(L,n,d) = luaL_optinteger(L, n, d)

'#define luaL_typename(L,i)	lua_typename(L, lua_type(L,(i)))

MACRO luaL_typename(L,i) = lua_typename(L, lua_type(L, i))

'#define luaL_dofile(L, fn) \
'	(luaL_loadfile(L, fn) || lua_pcall(L, 0, LUA_MULTRET, 0))

FUNCTION luaL_dofile (BYVAL L AS DWORD, BYREF fn AS ASCIIZ) AS LONG
   LOCAL lr1, lr2 AS LONG
   lr1 = luaL_loadfile(L, fn)
   lr2 = lua_pcall(L, 0, %LUA_MULTRET, 0)
   FUNCTION = lr1 OR lr2
END FUNCTION

'#define luaL_dostring(L, s) \
'	(luaL_loadstring(L, s) || lua_pcall(L, 0, LUA_MULTRET, 0))

FUNCTION luaL_dostring(BYVAL L AS DWORD, BYREF s AS ASCIIZ) AS LONG
   LOCAL lr1, lr2 AS LONG
   lr1 = luaL_loadstring(L, s)
   lr2 = lua_pcall(L, 0, %LUA_MULTRET, 0)
   FUNCTION = lr1 OR lr2
END FUNCTION

'#define luaL_getmetatable(L,n)	(lua_getfield(L, LUA_REGISTRYINDEX, (n)))

MACRO luaL_getmetatable(L,n) = lua_getfield(L, %LUA_REGISTRYINDEX, n)

'#define luaL_opt(L,f,n,d)	(lua_isnoneornil(L,(n)) ? (d) : f(L,(n)))

'/*
'** {======================================================
'** Generic Buffer manipulation
'** =======================================================
'*/

'typedef struct luaL_Buffer {
'  char *p;			/* current position in buffer */
'  int lvl;  /* number of strings in the stack (level) */
'  lua_State *L;
'  char buffer[LUAL_BUFFERSIZE];
'} luaL_Buffer;

TYPE luaL_Buffer
  p      AS ASCIIZ PTR
  lvl    AS LONG
  L      AS DWORD
  buffer AS ASCIIZ * %LUAL_BUFFERSIZE
END TYPE

'#define luaL_addchar(B,c) \
'  ((void)((B)->p < ((B)->buffer+LUAL_BUFFERSIZE) || luaL_prepbuffer(B)), \
'   (*(B)->p++ = (char)(c)))

'/* compatibility only */
'#define luaL_putchar(B,c)	luaL_addchar(B,c)

'#define luaL_addsize(B,n)	((B)->p += (n))

DECLARE SUB luaL_buffinit LIB "LUA5.1.DLL" ALIAS "luaL_buffinit" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF luaL_Buffer _                 ' luaL_Buffer *B
 )                                     ' void

DECLARE FUNCTION luaL_prepbuffer LIB "LUA5.1.DLL" ALIAS "luaL_prepbuffer" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
 ) AS DWORD                            ' char *

DECLARE SUB luaL_addlstring LIB "LUA5.1.DLL" ALIAS "luaL_addlstring" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
 , BYREF ASCIIZ _                      ' const char *s
 , BYVAL DWORD _                       ' size_t l
 )                                     ' void

DECLARE SUB luaL_addstring LIB "LUA5.1.DLL" ALIAS "luaL_addstring" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
 , BYREF ASCIIZ _                      ' const char *s
 )                                     ' void

DECLARE SUB luaL_addvalue LIB "LUA5.1.DLL" ALIAS "luaL_addvalue" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
 )                                     ' void

DECLARE SUB luaL_pushresult LIB "LUA5.1.DLL" ALIAS "luaL_pushresult" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
 )                                     ' void


'/* }====================================================== */


'/* compatibility with ref system */

'/* pre-defined references */
'#define LUA_NOREF       (-2)
'#define LUA_REFNIL      (-1)

%LUA_NOREF       = -2
%LUA_REFNIL      = -1

'#define lua_ref(L,lock) ((lock) ? luaL_ref(L, LUA_REGISTRYINDEX) : \
'      (lua_pushstring(L, "unlocked references are obsolete"), lua_error(L), 0))

'#define lua_unref(L,ref)        luaL_unref(L, LUA_REGISTRYINDEX, (ref))

MACRO lua_unref(L,lref) = luaL_unref(L, %LUA_REGISTRYINDEX, lref)

'#define lua_getref(L,ref)       lua_rawgeti(L, LUA_REGISTRYINDEX, (ref))

MACRO lua_getref(L,lref) = lua_rawgeti(L, %LUA_REGISTRYINDEX, lref)

'#define luaL_reg	luaL_Reg

'#endif


#ENDIF
