'/*
'** $Id: lua.h,v 1.218a 2006/06/02 15:34:00 roberto Exp $
'** Lua - An Extensible Extension Language
'** Lua.org, PUC-Rio, Brazil (http://www.lua.org)
'** See Copyright Notice at the end of this file
'*/

#IF NOT %DEF(%LUA_INC)
    %LUA_INC = 1

'#include <stdarg.h>
'#include <stddef.h>

#INCLUDE "luaconf.inc"

$LUA_VERSION     = "Lua 5.1"
$LUA_RELEASE     = "Lua 5.1.2"
%LUA_VERSION_NUM = 501
$LUA_COPYRIGHT   = "Copyright (C) 1994-2007 Lua.org, PUC-Rio"
$LUA_AUTHORS     = "R. Ierusalimschy, L. H. de Figueiredo & W. Celes"


'/* mark for precompiled code (`<esc>Lua') */
'#define   LUA_SIGNATURE   "\033Lua"
$LUA_SIGNATURE   = CHR$(27) & "Lua"

'/* option for multiple returns in `lua_pcall' and `lua_call' */
%LUA_MULTRET   = -1

'/*
'** pseudo-indices
'*/
%LUA_REGISTRYINDEX  = -10000
%LUA_ENVIRONINDEX   = -10001
%LUA_GLOBALSINDEX   = -10002
MACRO lua_upvalueindex(i) = %LUA_GLOBALSINDEX - i

'/* thread status; 0 is OK */
%LUA_YIELD     = 1
%LUA_ERRRUN    = 2
%LUA_ERRSYNTAX = 3
%LUA_ERRMEM    = 4
%LUA_ERRERR    = 5

'typedef struct lua_State lua_State;

'typedef int (*lua_CFunction) (lua_State *L);


'/*
'** functions that read/write blocks when loading/dumping Lua chunks
'*/
'typedef const char * (*lua_Reader) (lua_State *L, void *ud, size_t *sz);

'typedef int (*lua_Writer) (lua_State *L, const void* p, size_t sz, void* ud);


'/*
'** prototype for memory-allocation functions
'*/
'typedef void * (*lua_Alloc) (void *ud, void *ptr, size_t osize, size_t nsize);


'/*
'** basic types
'*/
%LUA_TNONE          = -1

%LUA_TNIL           = 0
%LUA_TBOOLEAN       = 1
%LUA_TLIGHTUSERDATA = 2
%LUA_TNUMBER        = 3
%LUA_TSTRING        = 4
%LUA_TTABLE         = 5
%LUA_TFUNCTION      = 6
%LUA_TUSERDATA      = 7
%LUA_TTHREAD        = 8

'/* minimum Lua stack available to a C function */
%LUA_MINSTACK  = 20

'/*
'** generic extra include file
'*/
'#if defined(LUA_USER_H)
'#include LUA_USER_H
'#endif


'/* type of numbers in Lua */
'typedef LUA_NUMBER lua_Number;


'/* type for integer functions */
'typedef LUA_INTEGER lua_Integer;



'/*
'** state manipulation
'*/

DECLARE FUNCTION lua_newstate LIB "LUA5.1.DLL" ALIAS "lua_newstate" ( _
   BYVAL DWORD _                       ' lua_Alloc f
 , BYVAL DWORD _                       ' void *ud
 ) AS DWORD                            ' lua_State *

DECLARE SUB lua_close LIB "LUA5.1.DLL" ALIAS "lua_close" ( _
   BYVAL DWORD _                       ' lua_State *L
 )                                     ' void

DECLARE FUNCTION lua_newthread LIB "LUA5.1.DLL" ALIAS "lua_newthread" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS DWORD                            ' lua_State *

DECLARE FUNCTION lua_atpanic LIB "LUA5.1.DLL" ALIAS "lua_atpanic" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_CFunction panicf
 ) AS DWORD                            ' lua_CFunction

'/*
'** basic stack manipulation
'*/


DECLARE FUNCTION lua_gettop LIB "LUA5.1.DLL" ALIAS "lua_gettop" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS LONG                             ' int

DECLARE SUB lua_settop LIB "LUA5.1.DLL" ALIAS "lua_settop" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_pushvalue LIB "LUA5.1.DLL" ALIAS "lua_pushvalue" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_remove LIB "LUA5.1.DLL" ALIAS "lua_remove" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_insert LIB "LUA5.1.DLL" ALIAS "lua_insert" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_replace LIB "LUA5.1.DLL" ALIAS "lua_replace" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE FUNCTION lua_checkstack LIB "LUA5.1.DLL" ALIAS "lua_checkstack" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int sz
 ) AS LONG                             ' int

DECLARE SUB lua_xmove LIB "LUA5.1.DLL" ALIAS "lua_xmove" ( _
   BYVAL DWORD _                       ' lua_State *from
 , BYVAL DWORD _                       ' lua_State *to
 , BYVAL LONG _                        ' int n
 )                                     ' void


'/*
'** access functions (stack -> C)
'*/

DECLARE FUNCTION lua_isnumber LIB "LUA5.1.DLL" ALIAS "lua_isnumber" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_isstring LIB "LUA5.1.DLL" ALIAS "lua_isstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_iscfunction LIB "LUA5.1.DLL" ALIAS "lua_iscfunction" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_isuserdata LIB "LUA5.1.DLL" ALIAS "lua_isuserdata" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_type LIB "LUA5.1.DLL" ALIAS "lua_type" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_typename LIB "LUA5.1.DLL" ALIAS "lua_typename" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int tp
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_equal LIB "LUA5.1.DLL" ALIAS "lua_equal" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx1
 , BYVAL LONG _                        ' int idx2
 ) AS LONG                             ' int

DECLARE FUNCTION lua_rawequal LIB "LUA5.1.DLL" ALIAS "lua_rawequal" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx1
 , BYVAL LONG _                        ' int idx2
 ) AS LONG                             ' int

DECLARE FUNCTION lua_lessthan LIB "LUA5.1.DLL" ALIAS "lua_lessthan" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx1
 , BYVAL LONG _                        ' int idx2
 ) AS LONG                             ' int

DECLARE FUNCTION lua_tonumber LIB "LUA5.1.DLL" ALIAS "lua_tonumber" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DOUBLE                           ' lua_Number

DECLARE FUNCTION lua_tointeger LIB "LUA5.1.DLL" ALIAS "lua_tointeger" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' lua_Integer

DECLARE FUNCTION lua_toboolean LIB "LUA5.1.DLL" ALIAS "lua_toboolean" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE FUNCTION lua_tolstring LIB "LUA5.1.DLL" ALIAS "lua_tolstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYREF DWORD _                       ' size_t *len
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_objlen LIB "LUA5.1.DLL" ALIAS "lua_objlen" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DWORD                            ' size_t

DECLARE FUNCTION lua_tocfunction LIB "LUA5.1.DLL" ALIAS "lua_tocfunction" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DWORD                            ' lua_CFunction

DECLARE FUNCTION lua_touserdata LIB "LUA5.1.DLL" ALIAS "lua_touserdata" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DWORD                            ' void *

DECLARE FUNCTION lua_tothread LIB "LUA5.1.DLL" ALIAS "lua_tothread" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DWORD                            ' lua_State *

DECLARE FUNCTION lua_topointer LIB "LUA5.1.DLL" ALIAS "lua_topointer" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS DWORD                            ' void *

'/*
'** push functions (C -> stack)
'*/

DECLARE SUB lua_pushnil LIB "LUA5.1.DLL" ALIAS "lua_pushnil" ( _
   BYVAL L AS DWORD _                  ' lua_State *L
 )                                     ' void

DECLARE SUB lua_pushnumber LIB "LUA5.1.DLL" ALIAS "lua_pushnumber" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DOUBLE _                      ' lua_Number n
 )                                     ' void

DECLARE SUB lua_pushinteger LIB "LUA5.1.DLL" ALIAS "lua_pushinteger" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' lua_Integer n
 )                                     ' void

DECLARE SUB lua_pushlstring LIB "LUA5.1.DLL" ALIAS "lua_pushlstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL STRING _                      ' const char *s
 , BYVAL DWORD _                       ' size_t l
 )                                     ' void

DECLARE SUB lua_pushstring LIB "LUA5.1.DLL" ALIAS "lua_pushstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *s
 )                                     ' void

DECLARE FUNCTION lua_pushvfstring LIB "LUA5.1.DLL" ALIAS "lua_pushvfstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *fmt
 , BYREF ANY _                         ' va_list argp
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_pushfstring CDECL LIB "LUA5.1.DLL" ALIAS "lua_pushfstring" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *fmt
 , OPTIONAL BYREF ANY _                ' optional arguments
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS DWORD                            ' const char *

DECLARE SUB lua_pushcclosure LIB "LUA5.1.DLL" ALIAS "lua_pushcclosure" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_CFunction fn
 , BYVAL LONG _                        ' int n
 )                                     ' void

DECLARE SUB lua_pushboolean LIB "LUA5.1.DLL" ALIAS "lua_pushboolean" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int b
 )                                     ' void

DECLARE SUB lua_pushlightuserdata LIB "LUA5.1.DLL" ALIAS "lua_pushlightuserdata" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' void *p
 )                                     ' void

DECLARE FUNCTION lua_pushthread LIB "LUA5.1.DLL" ALIAS "lua_pushthread" ( _
   BYVAL L AS DWORD _                  ' lua_State *L
 ) AS LONG                             ' int

'/*
'** get functions (Lua -> stack)
'*/

DECLARE SUB lua_gettable LIB "LUA5.1.DLL" ALIAS "lua_gettable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_getfield LIB "LUA5.1.DLL" ALIAS "lua_getfield" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYREF ASCIIZ _                      ' const char *k
 )                                     ' void

DECLARE SUB lua_rawget LIB "LUA5.1.DLL" ALIAS "lua_rawget" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_rawgeti LIB "LUA5.1.DLL" ALIAS "lua_rawgeti" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYVAL LONG _                        ' int n
 )                                     ' void

DECLARE SUB lua_createtable LIB "LUA5.1.DLL" ALIAS "lua_createtable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narr
 , BYVAL LONG _                        ' int nrec
 )                                     ' void

DECLARE FUNCTION lua_newuserdata LIB "LUA5.1.DLL" ALIAS "lua_newuserdata" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' size_t sz
 ) AS DWORD                            ' void *

DECLARE FUNCTION lua_getmetatable LIB "LUA5.1.DLL" ALIAS "lua_getmetatable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int objindex
 ) AS LONG                             ' int

DECLARE SUB lua_getfenv LIB "LUA5.1.DLL" ALIAS "lua_getfenv" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void


'/*
'** set functions (stack -> Lua)
'*/

DECLARE SUB lua_settable LIB "LUA5.1.DLL" ALIAS "lua_settable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_setfield LIB "LUA5.1.DLL" ALIAS "lua_setfield" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYREF ASCIIZ _                      ' const char *k
 )                                     ' void

DECLARE SUB lua_rawset LIB "LUA5.1.DLL" ALIAS "lua_rawset" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 )                                     ' void

DECLARE SUB lua_rawseti LIB "LUA5.1.DLL" ALIAS "lua_rawseti" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 , BYVAL LONG _                        ' int n
 )                                     ' void

DECLARE FUNCTION lua_setmetatable LIB "LUA5.1.DLL" ALIAS "lua_setmetatable" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int objindex
 ) AS LONG                             ' int

DECLARE FUNCTION lua_setfenv LIB "LUA5.1.DLL" ALIAS "lua_setfenv" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

'/*
'** `load' and `call' functions (load and run Lua code)
'*/

DECLARE SUB lua_call LIB "LUA5.1.DLL" ALIAS "lua_call" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int nargs
 , BYVAL LONG _                        ' int nresults
 )                                     ' void

DECLARE FUNCTION lua_pcall LIB "LUA5.1.DLL" ALIAS "lua_pcall" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int nargs
 , BYVAL LONG _                        ' int nresults
 , BYVAL LONG _                        ' int errfunc
 ) AS LONG                             ' int

DECLARE FUNCTION lua_cpcall LIB "LUA5.1.DLL" ALIAS "lua_cpcall" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_CFunction func
 , BYVAL DWORD _                       ' void *ud
 ) AS LONG                             ' int

DECLARE FUNCTION lua_load LIB "LUA5.1.DLL" ALIAS "lua_load" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_Reader reader
 , BYVAL DWORD _                       ' void *dt
 , BYREF ASCIIZ _                      ' const char *chunkname
 ) AS LONG                             ' int

DECLARE FUNCTION lua_dump LIB "LUA5.1.DLL" ALIAS "lua_dump" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_Writer writer
 , BYVAL DWORD _                       ' void *data
 ) AS LONG                             ' int


'/*
'** coroutine functions
'*/

DECLARE FUNCTION lua_yield LIB "LUA5.1.DLL" ALIAS "lua_yield" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int nresults
 ) AS LONG                             ' int

DECLARE FUNCTION lua_resume LIB "LUA5.1.DLL" ALIAS "lua_resume" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int narg
 ) AS LONG                             ' int

DECLARE FUNCTION lua_status LIB "LUA5.1.DLL" ALIAS "lua_status" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS LONG                             ' int

'/*
'** garbage-collection function and options
'*/

%LUA_GCSTOP       = 0
%LUA_GCRESTART    = 1
%LUA_GCCOLLECT    = 2
%LUA_GCCOUNT      = 3
%LUA_GCCOUNTB     = 4
%LUA_GCSTEP       = 5
%LUA_GCSETPAUSE   = 6
%LUA_GCSETSTEPMUL = 7

DECLARE FUNCTION lua_gc LIB "LUA5.1.DLL" ALIAS "lua_gc" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int what
 , BYVAL LONG _                        ' int data
 ) AS LONG                             ' int


'/*
'** miscellaneous functions
'*/

DECLARE FUNCTION lua_error LIB "LUA5.1.DLL" ALIAS "lua_error" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS LONG                             ' int

DECLARE FUNCTION lua_next LIB "LUA5.1.DLL" ALIAS "lua_next" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int idx
 ) AS LONG                             ' int

DECLARE SUB lua_concat LIB "LUA5.1.DLL" ALIAS "lua_concat" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int n
 )                                     ' void

DECLARE FUNCTION lua_getallocf LIB "LUA5.1.DLL" ALIAS "lua_getallocf" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF DWORD _                       ' void **ud
 ) AS DWORD                            ' lua_Alloc

DECLARE SUB lua_setallocf LIB "LUA5.1.DLL" ALIAS "lua_setallocf" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_Alloc f
 , BYVAL DWORD _                       ' void *ud
 )                                     ' void


'/*
'** ===============================================================
'** some useful macros
'** ===============================================================
'*/

'#define lua_pop(L,n)      lua_settop(L, -(n)-1)

MACRO lua_pop(L,n) = lua_settop(L, -(n)-1)

'#define lua_newtable(L)      lua_createtable(L, 0, 0)

MACRO lua_newtable(L) = lua_createtable(L, 0, 0)

'#define lua_pushcfunction(L,f)   lua_pushcclosure(L, (f), 0)

MACRO lua_pushcfunction(L,f) = lua_pushcclosure(L, f, 0)

'#define lua_setglobal(L,s)   lua_setfield(L, LUA_GLOBALSINDEX, (s))

SUB lua_setglobal (BYVAL L AS DWORD, BYREF s AS ASCIIZ)
   lua_setfield(L, %LUA_GLOBALSINDEX, s)
END SUB

'#define lua_register(L,n,f) (lua_pushcfunction(L, (f)), lua_setglobal(L, (n)))

SUB lua_register(BYVAL L AS DWORD, BYREF n AS ASCIIZ, BYVAL f AS DWORD)
   lua_pushcfunction(L, f)
   lua_setglobal(L, n)
END SUB

'#define lua_strlen(L,i)      lua_objlen(L, (i))

MACRO lua_strlen(L,i) = lua_objlen(L, i)

'#define lua_isfunction(L,n)   (lua_type(L, (n)) == LUA_TFUNCTION)
'#define lua_istable(L,n)   (lua_type(L, (n)) == LUA_TTABLE)
'#define lua_islightuserdata(L,n)   (lua_type(L, (n)) == LUA_TLIGHTUSERDATA)
'#define lua_isnil(L,n)      (lua_type(L, (n)) == LUA_TNIL)
'#define lua_isboolean(L,n)   (lua_type(L, (n)) == LUA_TBOOLEAN)
'#define lua_isthread(L,n)   (lua_type(L, (n)) == LUA_TTHREAD)
'#define lua_isnone(L,n)      (lua_type(L, (n)) == LUA_TNONE)
'#define lua_isnoneornil(L, n)   (lua_type(L, (n)) <= 0)

MACRO lua_isfunction(L,n) = lua_type(L, n) = %LUA_TFUNCTION
MACRO lua_istable(L,n) = lua_type(L, n) = %LUA_TTABLE
MACRO lua_islightuserdata(L,n) = lua_type(L, n) = %LUA_TLIGHTUSERDATA
MACRO lua_isnil(L,n) = lua_type(L, n) = %LUA_TNIL
MACRO lua_isboolean(L,n) = lua_type(L, n) = %LUA_TBOOLEAN
MACRO lua_isthread(L,n) = lua_type(L, n) = %LUA_TTHREAD
MACRO lua_isnone(L,n) = lua_type(L, n) = %LUA_TNONE
MACRO lua_isnoneornil(L,n) = lua_type(L, n) <= 0

'#define lua_pushliteral(L, s)   \
'   lua_pushlstring(L, "" s, (sizeof(s)/sizeof(char))-1)

SUB lua_pushliteral (BYVAL L AS DWORD, BYVAL s AS STRING)
   lua_pushlstring(L, s, LEN(s))
END SUB

'#define lua_getglobal(L,s)   lua_getfield(L, LUA_GLOBALSINDEX, (s))

SUB lua_getglobal (BYVAL L AS DWORD, BYREF s AS ASCIIZ)
   lua_getfield(L, %LUA_GLOBALSINDEX, s)
END SUB

'#define lua_tostring(L,i)   lua_tolstring(L, (i), NULL)

MACRO lua_tostring(L,i) = lua_tolstring(L, i, %NULL)


'/*
'** compatibility macros and functions
'*/

'#define lua_open()   luaL_newstate()
MACRO lua_open() = luaL_newstate()

'#define lua_getregistry(L)   lua_pushvalue(L, LUA_REGISTRYINDEX)
MACRO lua_getregistry(L) = lua_pushvalue(L, %LUA_REGISTRYINDEX)

'#define lua_getgccount(L)   lua_gc(L, LUA_GCCOUNT, 0)
MACRO lua_getgccount(L) = lua_gc(L, %LUA_GCCOUNT, 0)

'#define lua_Chunkreader      lua_Reader
'#define lua_Chunkwriter      lua_Writer


'/*
'** {======================================================================
'** Debug API
'** =======================================================================
'*/


'/*
'** Event codes
'*/

%LUA_HOOKCALL    = 0
%LUA_HOOKRET     = 1
%LUA_HOOKLINE    = 2
%LUA_HOOKCOUNT   = 3
%LUA_HOOKTAILRET = 4

'/*
'** Event masks
'*/

%LUA_MASKCALL  = 1   ' (1 << LUA_HOOKCALL)
%LUA_MASKRET   = 2   ' (1 << LUA_HOOKRET)
%LUA_MASKLINE  = 4   ' (1 << LUA_HOOKLINE)
%LUA_MASKCOUNT = 8   ' (1 << LUA_HOOKCOUNT)

'struct lua_Debug {
'  int event;
'  const char *name;   /* (n) */
'  const char *namewhat;   /* (n) `global', `local', `field', `method' */
'  const char *what;   /* (S) `Lua', `C', `main', `tail' */
'  const char *source;   /* (S) */
'  int currentline;   /* (l) */
'  int nups;      /* (u) number of upvalues */
'  int linedefined;   /* (S) */
'  int lastlinedefined;   /* (S) */
'  char short_src[LUA_IDSIZE]; /* (S) */
'  /* private part */
'  int i_ci;  /* active function */
'};

TYPE lua_Debug
  event           AS LONG
  name            AS ASCIIZ PTR
  namewhat        AS ASCIIZ PTR
  what            AS ASCIIZ PTR
  source          AS ASCIIZ PTR
  currentline     AS LONG
  nups            AS LONG
  linedefined     AS LONG
  lastlinedefined AS LONG
  short_src       AS ASCIIZ * %LUA_IDSIZE
  ' /* private part */
  i_ci            AS LONG
END TYPE

'typedef struct lua_Debug lua_Debug;  /* activation record */


'/* Functions to be called by the debuger in specific events */

DECLARE FUNCTION lua_getstack LIB "LUA5.1.DLL" ALIAS "lua_getstack" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int level
 , BYREF lua_Debug _                   ' lua_Debug *ar
 ) AS LONG                             ' int

DECLARE FUNCTION lua_getinfo LIB "LUA5.1.DLL" ALIAS "lua_getinfo" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF ASCIIZ _                      ' const char *what
 , BYREF lua_Debug _                   ' lua_Debug *ar
 ) AS LONG                             ' int

DECLARE FUNCTION lua_getlocal LIB "LUA5.1.DLL" ALIAS "lua_getlocal" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF lua_Debug _                   ' const lua_Debug *ar
 , BYVAL LONG _                        ' int n
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_setlocal LIB "LUA5.1.DLL" ALIAS "lua_setlocal" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYREF lua_Debug _                   ' const lua_Debug *ar
 , BYVAL LONG _                        ' int n
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_getupvalue LIB "LUA5.1.DLL" ALIAS "lua_getupvalue" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int funcindex
 , BYVAL LONG _                        ' int n
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_setupvalue LIB "LUA5.1.DLL" ALIAS "lua_setupvalue" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL LONG _                        ' int funcindex
 , BYVAL LONG _                        ' int n
 ) AS DWORD                            ' const char *

DECLARE FUNCTION lua_sethook LIB "LUA5.1.DLL" ALIAS "lua_sethook" ( _
   BYVAL DWORD _                       ' lua_State *L
 , BYVAL DWORD _                       ' lua_Hook func
 , BYVAL LONG _                        ' int mask
 , BYVAL LONG _                        ' int count
 ) AS LONG                             ' int

DECLARE FUNCTION lua_gethook LIB "LUA5.1.DLL" ALIAS "lua_gethook" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS DWORD                            ' lua_Hook

DECLARE FUNCTION lua_gethookmask LIB "LUA5.1.DLL" ALIAS "lua_gethookmask" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS LONG                             ' int

DECLARE FUNCTION lua_gethookcount LIB "LUA5.1.DLL" ALIAS "lua_gethookcount" ( _
   BYVAL DWORD _                       ' lua_State *L
 ) AS LONG                             ' int


'/* }====================================================================== */


'/******************************************************************************
'* Copyright (C) 1994-2007 Lua.org, PUC-Rio.  All rights reserved.
'*
'* Permission is hereby granted, free of charge, to any person obtaining
'* a copy of this software and associated documentation files (the
'* "Software"), to deal in the Software without restriction, including
'* without limitation the rights to use, copy, modify, merge, publish,
'* distribute, sublicense, and/or sell copies of the Software, and to
'* permit persons to whom the Software is furnished to do so, subject to
'* the following conditions:
'*
'* The above copyright notice and this permission notice shall be
'* included in all copies or substantial portions of the Software.
'*
'* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'******************************************************************************/


'#endif

#ENDIF
